/* eslint-disable import/no-extraneous-dependencies */
const request = require('supertest');

const app = require('../src/app');

describe('GET /v1/eixos', () => {
  it('deve retornar um array de eixos', (done) => {
    request(app)
      .get('/v1/eixos')
      .set('Accept', 'application/json')
      .expect('Content-Type', /json/)
      .expect(200)
      .expect((res) => {
        if (typeof res.body !== typeof []) throw new Error(`Deveria retornar um array mas retornou [${typeof res.body}]`);
        if (res.body.length < 1) throw new Error('Retornou um array vazio!');
        const receivedProperties = Object.keys(res.body[0]);
        const expectedProperties = ['id', 'nome'];
        expectedProperties.forEach((prop) => {
          if (!receivedProperties.includes(prop)) throw new Error(`Objeto retornado não possui o campo [${prop}]!`);
        });
      })
      .end(done);
  });
});
