/*
 * Autor: Andrew Solera (asolera@prefeitura.sp.gov.br)
 * Data: 24/05/2021
 * Descrição: Cria as tabelas que irão receber os dados brutos contidos nas planilhas que a SGM irá consolidar.
 */

CREATE TABLE raw_canal (
    nome_canal VARCHAR(255) NULL,
    introducao TEXT NULL
);

CREATE TABLE raw_contribuicao (
    id_municipe VARCHAR(255) NULL,
    id_contribuicao VARCHAR(255) NULL,
    canal VARCHAR(255) NULL,
    contribuicao_integra TEXT NULL
);

CREATE TABLE raw_municipe (
    id_municipe VARCHAR(255) NULL,
    nome VARCHAR(255) NULL
);

CREATE TABLE raw_subtema (
    id_subtema VARCHAR(255) NULL,
    subtema VARCHAR(255) NULL,
    categoria VARCHAR(255) NULL,
    devolutiva TEXT NULL,
    eixo VARCHAR(255) NULL,
    secretaria_sigla VARCHAR(255) NULL
);

CREATE TABLE raw_sugestao (
    id_contribuicao VARCHAR(255) NULL,
    id_sugestao VARCHAR(255) NULL,
    sugestao TEXT NULL,
    subprefeitura VARCHAR(255) NULL,
    id_subtema VARCHAR(255) NULL
);

COPY raw_canal FROM '/docker-entrypoint-initdb.d/csv/canais.csv' DELIMITER ',' CSV HEADER ENCODING 'UTF8';
COPY raw_contribuicao FROM '/docker-entrypoint-initdb.d/csv/contribuicoes.csv' DELIMITER ',' CSV HEADER ENCODING 'UTF8';
COPY raw_municipe FROM '/docker-entrypoint-initdb.d/csv/municipes.csv' DELIMITER ',' CSV HEADER ENCODING 'UTF8';
COPY raw_sugestao FROM '/docker-entrypoint-initdb.d/csv/sugestoes.csv' DELIMITER ',' CSV HEADER ENCODING 'UTF8';
COPY raw_subtema FROM '/docker-entrypoint-initdb.d/csv/subtemas.csv' DELIMITER ',' CSV HEADER ENCODING 'UTF8';
