# Release Notes - Versão 1.0.0-rc1

A [versão 1.0.0-rc1](https://codigoaberto.prefeitura.sp.gov.br/sgm/devolutivas-pdm/-/milestones/1) é a primeira versão do site, entregue em 15/06/2021 à equipe da SGM para homologação, contendo as principais funcionalidades do site para o lançamento oficial.

## Funcionalidades / Entregas

- Landing page com formulário de pesquisa
- Menu lateral com links externos
- Tela com resultados de pesquisa
- Modal contendo detalhamento das contribuições
- Layout mobile / responsivo
- API contendo as listagens de domínio e pesquisa de contribuições
- Documentação da API com Swagger
- Banco de dados com amostra da base de devolutivas e pesquisa textual
- Conteinerização do ambiente com Docker
- Configuração de edge router e rate limits com Traefik
- Configuração do servidor na nuvem Prodam

## Screenshots

### Versão Desktop

![Landing Page](screenshots/ss-desktop-01.png)
![Landing Page com menu lateral](screenshots/ss-desktop-02.png)
![Landing Page com formulário preenchido](screenshots/ss-desktop-03.png)
![Tela de carregamento](screenshots/ss-desktop-04.png)
![Resultado de pesquisa](screenshots/ss-desktop-05.png)
![Modal com detalhamento da contribuição](screenshots/ss-desktop-06.png)
![Nenhum resultado encontrado](screenshots/ss-desktop-07.png)
![Erro ao pesquisar](screenshots/ss-desktop-08.png)

### Versão Mobile

![Landing Page](screenshots/ss-mobile-01.png)
![Landing Page com menu lateral](screenshots/ss-mobile-02.png)
![Tela de carregamento](screenshots/ss-mobile-03.png)
![Resultado de pesquisa](screenshots/ss-mobile-04.png)
![Menu lateral de pesquisa](screenshots/ss-mobile-05.png)
![Modal com detalhamento da contribuição](screenshots/ss-mobile-06.png)
![Modal com detalhamento da contribuição](screenshots/ss-mobile-07.png)
![Nenhum resultado encontrado](screenshots/ss-mobile-08.png)
![Erro ao pesquisar](screenshots/ss-mobile-09.png)
