/* eslint-disable indent */
import Store from '../Store';

/* eslint-disable no-useless-constructor */
class CategoriaComponent extends HTMLElement {
  constructor() {
    super();
    this.armazenarSelecao();
    this.atualizarSelecao();
  }

  armazenarSelecao() {
    this.addEventListener('change', (e) => {
      const idCategoriaSelecionada = e.target.value;
      if (idCategoriaSelecionada === '0') {
        delete Store.data.filtros.idCategoria;
      } else {
        Store.data.filtros.idCategoria = idCategoriaSelecionada;
      }
      const event = new CustomEvent('categoria-selecionada', { detail: idCategoriaSelecionada });
      Store.bus.dispatchEvent(event);
    });
  }

  atualizarSelecao() {
    Store.bus.addEventListener('categoria-selecionada', (e) => {
      const idCategoriaSelecionada = e.detail;
      // Atualiza todos os selects
      this.childNodes[1].childNodes[3].value = idCategoriaSelecionada;
    });
  }

  configurarLimpar() {
    const divLimparSelect = this.children.item(0).children.item(2);

    divLimparSelect.addEventListener('click', () => {
      delete Store.data.filtros.idCategoria;
      this.childNodes[1].childNodes[3].value = 0;

      const event = new CustomEvent('categoria-selecionada', { detail: 0 });
      Store.bus.dispatchEvent(event);
    });
  }

  connectedCallback() {
    this.innerHTML = `
      <fieldset>
        <label for="select-categoria">Busca por categoria:</label>
        <select id="select-categoria">
          <option value="0"></option>
          ${Store.data.categorias.map((categoria) => `<option value="${categoria.id}">${categoria.nome}</option>`).join('')}
        </select>
        <div class="form-pesquisa--select--limpar">&times;</div>
      </fieldset>
    `;

    this.configurarLimpar();
  }
}

customElements.define('select-categoria', CategoriaComponent);
