/* eslint-disable indent */
import Store from '../Store';

/* eslint-disable no-useless-constructor */
class EixoComponent extends HTMLElement {
  constructor() {
    super();
    this.armazenarSelecao();
    this.atualizarSelecao();
  }

  armazenarSelecao() {
    this.addEventListener('change', (e) => {
      const idEixoSelecionado = e.target.value;
      if (idEixoSelecionado === '0') {
        delete Store.data.filtros.idEixo;
      } else {
        Store.data.filtros.idEixo = idEixoSelecionado;
      }
      const event = new CustomEvent('eixo-selecionado', { detail: idEixoSelecionado });
      Store.bus.dispatchEvent(event);
    });
  }

  atualizarSelecao() {
    Store.bus.addEventListener('eixo-selecionado', (e) => {
      const idEixoSelecionado = e.detail;
      // Atualiza todos os selects
      this.childNodes[1].childNodes[3].value = idEixoSelecionado;
    });
  }

  configurarLimpar() {
    const divLimparSelect = this.children.item(0).children.item(2);

    divLimparSelect.addEventListener('click', () => {
      delete Store.data.filtros.idEixo;
      this.childNodes[1].childNodes[3].value = 0;

      const event = new CustomEvent('eixo-selecionado', { detail: 0 });
      Store.bus.dispatchEvent(event);
    });
  }

  connectedCallback() {
    this.innerHTML = `
      <fieldset>
        <label for="select-eixo">Busca por eixo:</label>
        <select id="select-eixo">
          <option value="0"></option>
          ${Store.data.eixos.map((eixo) => `<option value="${eixo.id}">${eixo.nome}</option>`).join('')}
        </select>
        <div class="form-pesquisa--select--limpar">&times;</div>
      </fieldset>
    `;

    this.configurarLimpar();
  }
}

customElements.define('select-eixo', EixoComponent);
