/* eslint-disable indent */
import Store from '../Store';

/* eslint-disable no-useless-constructor */
class PesquisaTextualComponent extends HTMLElement {
  constructor() {
    super();
    this.armazenarTexto();
    this.atualizarTexto();
  }

  armazenarTexto() {
    this.addEventListener('keyup', (e) => {
      const textoDigitado = e.target.value;
      if (textoDigitado.length < 1) {
        delete Store.data.filtros.termoPesquisa;
      } else {
        Store.data.filtros.termoPesquisa = textoDigitado;
      }
      const event = new CustomEvent('texto-digitado', { detail: textoDigitado });
      Store.bus.dispatchEvent(event);
    });
  }

  atualizarTexto() {
    Store.bus.addEventListener('texto-digitado', (e) => {
      const textoDigitado = e.detail;
      this.childNodes[1].childNodes[3].value = textoDigitado;
    });
  }

  connectedCallback() {
    this.innerHTML = `
      <fieldset>
        <label for="text-pesquisatextual">Digite o que deseja encontrar: </label>
        <input type="text" id="text-pesquisatextual">
      </fieldset>
    `;
  }
}

customElements.define('text-pesquisatextual', PesquisaTextualComponent);
