/* eslint-disable indent */
import Store from '../Store';

/* eslint-disable no-useless-constructor */
class SecretariaComponent extends HTMLElement {
  constructor() {
    super();
    this.armazenarSelecao();
    this.atualizarSelecao();
  }

  armazenarSelecao() {
    this.addEventListener('change', (e) => {
      const idSecretariaSelecionada = e.target.value;
      if (idSecretariaSelecionada === '0') {
        delete Store.data.filtros.idSecretaria;
      } else {
        Store.data.filtros.idSecretaria = idSecretariaSelecionada;
      }
      const event = new CustomEvent('secretaria-selecionada', { detail: idSecretariaSelecionada });
      Store.bus.dispatchEvent(event);
    });
  }

  atualizarSelecao() {
    Store.bus.addEventListener('secretaria-selecionada', (e) => {
      const idSecretariaSelecionada = e.detail;
      // Atualiza todos os selects
      this.childNodes[1].childNodes[3].value = idSecretariaSelecionada;
    });
  }

  configurarLimpar() {
    const divLimparSelect = this.children.item(0).children.item(2);

    divLimparSelect.addEventListener('click', () => {
      delete Store.data.filtros.idSecretaria;
      this.childNodes[1].childNodes[3].value = 0;

      const event = new CustomEvent('secretaria-selecionada', { detail: 0 });
      Store.bus.dispatchEvent(event);
    });
  }

  connectedCallback() {
    this.innerHTML = `
      <fieldset>
        <label for="select-secretaria">Busca por secretaria:</label>
        <select id="select-secretaria">
          <option value="0"></option>
          ${Store.data.secretarias.map((secretaria) => `<option value="${secretaria.id}">${secretaria.sigla}</option>`).join('')}
        </select>
        <div class="form-pesquisa--select--limpar">&times;</div>
      </fieldset>
    `;

    this.configurarLimpar();
  }
}

customElements.define('select-secretaria', SecretariaComponent);
