/* eslint-disable indent */
import Store from '../Store';

/* eslint-disable no-useless-constructor */
class SubprefeituraComponent extends HTMLElement {
  constructor() {
    super();
    this.armazenarSelecao();
    this.atualizarSelecao();
  }

  armazenarSelecao() {
    this.addEventListener('change', (e) => {
      const idSubprefeituraSelecionada = e.target.value;
      if (idSubprefeituraSelecionada === '0') {
        delete Store.data.filtros.idSubprefeitura;
      } else {
        Store.data.filtros.idSubprefeitura = idSubprefeituraSelecionada;
      }
      const event = new CustomEvent('subprefeitura-selecionada', { detail: idSubprefeituraSelecionada });
      Store.bus.dispatchEvent(event);
    });
  }

  atualizarSelecao() {
    Store.bus.addEventListener('subprefeitura-selecionada', (e) => {
      const idSubprefeituraSelecionada = e.detail;
      // Atualiza todos os selects
      this.childNodes[1].childNodes[3].value = idSubprefeituraSelecionada;
    });
  }

  configurarLimpar() {
    const divLimparSelect = this.children.item(0).children.item(2);

    divLimparSelect.addEventListener('click', () => {
      delete Store.data.filtros.idSubprefeitura;
      this.childNodes[1].childNodes[3].value = 0;

      const event = new CustomEvent('subprefeitura-selecionada', { detail: 0 });
      Store.bus.dispatchEvent(event);
    });
  }

  connectedCallback() {
    this.innerHTML = `
      <fieldset>
        <label for="select-subprefeitura">Busca por subprefeitura:</label>
        <select id="select-subprefeitura">
          <option value="0"></option>
          ${Store.data.subprefeituras.map((subprefeitura) => `<option value="${subprefeitura.id}">${subprefeitura.nome}</option>`).join('')}
        </select>
        <div class="form-pesquisa--select--limpar">&times;</div>
      </fieldset>
    `;

    this.configurarLimpar();
  }
}

customElements.define('select-subprefeitura', SubprefeituraComponent);
